#!/usr/bin/python
# -*- coding: utf-8 -*-
#"""
#KOPR 1.0
#"""

import koprfunc
import koprfig
import comephem
import matplotlib.pyplot as plt

sc = koprfig.VisMapDialog()

destig = '103P'
date  = '2023/09/04' 
time =  '02:00'

params = [['CER01', 'Jakub', 'Cerny'], ['5', '2', '1', '60000', '3', '2', '5', '200', '5', '2', '0', '0', '0'], ['Praha', '15.0', '50.0', '500', '2'], ['FRAM', 'C', '200', '1000', '', ''], ['Nagler 14', '14', '80'], ['G2-1000BI', 'MG2', 'CCD47-10', 'E2V', '1055', '1022', '13', '13', '780']]
comet, moonalt, moonp, sunalt = koprfunc.CometObsInf(destig, date, time, params[2][1], params[2][2], params[2][3])
ra, de = comephem.j2000rade( comet.ra, comet.de, date, time )
lm = round((comet.mag+2.)*2. , 0 )/2.
if lm < 6:
  lm = 6
elif lm > 18:
  lm = 18
            
if lm <= 7:
  cat = 'YBSC5'
  fov = 10.
elif 7 < lm <= 12:
  cat = 'TYC-2'
  fov = 4.
else:
  cat = 'UCAC4'
  fov = 2.
  
mapparam = [ str(round(ra*15.,2)), str(round(de,2)), str(fov), str(lm), cat, str(round(ra*15.,2)), str(round(de,2)), destig ]
try:
      refstar, refstars = {}, []
          
      sc.pt_plot.set_xdata([])
      sc.pt_plot.set_ydata([])

      sc.tpt_plot.set_xdata([])
      sc.tpt_plot.set_ydata([])

      #init new map
      header, starlist, vizdata = koprfunc.GenerateMap(mapparam, [])
      # *** PLOT COMET POINTER ***
      cpx, cpy = koprfunc.GetComaXY(header, mapparam)
      sc.com_point.set_xdata( [cpx] )
      sc.com_point.set_ydata( [cpy] )

      # *** PLOT SCALE ***
      scale = float(mapparam[2])/2.2
      if scale > 1:
          scale, pxsize = str(int(scale))+' deg', (float(int(scale))*2048.)/float(mapparam[2]) 
      else:
          scale, pxsize = str(int(scale*6)*10 )+' arcmin', (float(int(scale*6))/6.*2048.) / float(mapparam[2])
      sc.scaletext.set_text(scale)

      sc.scalept.set_xdata( [1024*2-40, 1024*2-40-pxsize] )
      sc.scalept.set_ydata( [ 768*2-40,  768*2-40] )
      
      # *** PLOT LIMIT MAG ***
      sc.limmag.set_text('Limit mag.: '+mapparam[3])
      
      # *** PLOT STARS ***
      sc.circle = []
      
      maglim = float(mapparam[3])
      if starlist[1]:
        for index, star in enumerate(starlist[1]):
          r = int (round( -1 * ( star[2] - maglim ) ) * 2 + 1)
          sc.circle.append(plt.Circle((star[0], star[1]), r, color='w'))
          sc.ax.add_artist(sc.circle[index])
      else:
        for index, star in enumerate(starlist[0]):
          r = int (round( -1 * ( star[2] - maglim ) ) * 2 + 1)
          sc.circle.append(plt.Circle((star[0], star[1]), r, color='w'))
          sc.ax.add_artist(sc.circle[index])
      
      sc.canvas.draw_idle()    
except Exception as e:
  print('Jen to neee, bleeeee ',e)

